////////////////////////////////////////////////////////////////////////////////
//
//                           Juan Pablo Ibaez 2007
//                      http://ing.juanpablo.googlepages.com
//                                    Copyrigth
//
////////////////////////////////////////////////////////////////////////////////

var spinnerF = null;

////////////////////////////////////////////////////////////////////////////////
//
// Load gadget's flyout function
//
////////////////////////////////////////////////////////////////////////////////
function loadFlyout()
{
    setUnitsLink.attachEvent("onmouseover", function(){ setUnitsLink.style.color = '33ffff';});
    setUnitsLink.attachEvent("onmouseout", function(){ setUnitsLink.style.color = 'ffffff';});
    setUnitsLink.attachEvent("onclick", function(){ setUnitsLink.style.color = '00ff33';});
    setUnitsLink.attachEvent("onfocus", function(){ setUnitsLink.style.color = '339999';});
    setUnitsLink.attachEvent("onblur", function(){ setUnitsLink.style.color = 'ffffff';});
    helpLink.attachEvent("onmouseover", function(){ helpLink.style.color = '33ffff';});
    helpLink.attachEvent("onmouseout", function(){ helpLink.style.color = 'ffffff';});
    helpLink.attachEvent("onclick", function(){ helpLink.style.color = '339999';});
    helpLink.attachEvent("onfocus", function(){ helpLink.style.color = '339999';});
    helpLink.attachEvent("onblur", function(){ helpLink.style.color = 'ffffff'; });
    
    spinnerF = new getSpinnerF('messageSpinnerF');
    ShowLoadingF(true,true,"Loading...");
    
    RetrieveComboCategory();
}
////////////////////////////////////////////////////////////////////////////////
//
// Retrieve Categories Combo's info from main gadget
//
////////////////////////////////////////////////////////////////////////////////
function RetrieveComboCategory()
{
    document.getElementById("comboCategoryDiv").innerHTML = System.Gadget.document.getElementById("data").value;
    if(System.Gadget.document.getElementById("status").value == "online") LoadUnits();
    else LoadUnitsOffline("0");
}
////////////////////////////////////////////////////////////////////////////////
//
// Load custom units
//
////////////////////////////////////////////////////////////////////////////////
function LoadCustomUnits()
{
        var xmlDoc = new ActiveXObject("Microsoft.XMLDOM");
        xmlDoc.loadXML(System.Gadget.document.getElementById("xmlCustom").value);
              
        var node = xmlDoc.documentElement;
        var categories = node.getElementsByTagName("Category");
        var conversions = categories[0].getElementsByTagName("Conversion");
        
        var htmlunit = "";
        var htmlunit1 = '<select id="comboUnit1" class="combo">';
        var htmlunit2 = '<select id="comboUnit2" class="combo">';
        
        for(var i=0; i<conversions.length; i=i+2)
        {
            var units = conversions[i].getAttributeNode("Name").value.split(" ");
            
            // Primera Unidad
            htmlunit = htmlunit + '<option value="' + i + '" title="' + units[0] + '"';
            if(units[0].length > 17) {
                htmlunit = htmlunit + '">' + units[0].substr(0,17) + '...';
            } else {
                htmlunit = htmlunit + '">' + units[0];
            }
            htmlunit = htmlunit + '</option>';
            
            // Segunda Unidad
            htmlunit = htmlunit + '<option value="' + i + '" title="' + units[2] + '"';
            if(units[0].length > 17) {
                htmlunit = htmlunit + '">' + units[2].substr(0,17) + '...';
            } else {
                htmlunit = htmlunit + '">' + units[2];
            }
            htmlunit = htmlunit + '</option>';
        }
        
        htmlunit1 = htmlunit1 + htmlunit + '</select>';
        htmlunit2 = htmlunit2 + htmlunit + '</select>';
        
        document.getElementById("comboUnit1Div").innerHTML = htmlunit1;
        document.getElementById("comboUnit2Div").innerHTML = htmlunit2;
        
        document.getElementById('VUnit1F').value = "";
        document.getElementById('VUnit2F').value = "";
}
////////////////////////////////////////////////////////////////////////////////
//
// Load units from selected category 
//
////////////////////////////////////////////////////////////////////////////////
function LoadUnits()
{   
    ShowLoadingF(true,true,"Loading units...");
    if (comboCategory.options(comboCategory.selectedIndex).text == "Custom") { 
        LoadCustomUnits();
        ShowLoadingF(false,false,"");
    } else {
        var tmp = comboCategory.options(comboCategory.selectedIndex).value.split(" ");
        RequestService(tmp[0],saveUnits);
    }
}
////////////////////////////////////////////////////////////////////////////////
//
// Get Offline Units
//
////////////////////////////////////////////////////////////////////////////////
function LoadUnitsOffline(pCategory)
{
    if (comboCategory.options(comboCategory.selectedIndex).value == "Custom"){
        LoadCustomUnits();
        return;
    }
    if(window.ActiveXObject)    
    {
        var xmlDoc = new ActiveXObject("Microsoft.XMLDOM");
        xmlDoc.loadXML(System.Gadget.document.getElementById("xmlOffline").value);
              
        var node = xmlDoc.documentElement;
        var categories = node.getElementsByTagName("Category");
        var conversions = categories[pCategory].getElementsByTagName("Conversion");
        
        var htmlunit = "";
        var htmlunit1 = '<select id="comboUnit1" class="combo">';
        var htmlunit2 = '<select id="comboUnit2" class="combo">';
        
        for(var i=0; i<conversions.length; i=i+2)
        {
            var units = conversions[i].getAttributeNode("Name").value.split(" ");
            
            // Primera Unidad
            htmlunit = htmlunit + '<option value="' + i + '" title="' + units[0] + '"';
            if(units[0].length > 17) {
                htmlunit = htmlunit + '">' + units[0].substr(0,17) + '...';
            } else {
                htmlunit = htmlunit + '">' + units[0];
            }
            htmlunit = htmlunit + '</option>';
            
            // Segunda Unidad
            htmlunit = htmlunit + '<option value="' + i + '" title="' + units[2] + '"';
            if(units[0].length > 17) {
                htmlunit = htmlunit + '">' + units[2].substr(0,17) + '...';
            } else {
                htmlunit = htmlunit + '">' + units[2];
            }
            htmlunit = htmlunit + '</option>';
        }
        
        htmlunit1 = htmlunit1 + htmlunit + '</select>';
        htmlunit2 = htmlunit2 + htmlunit + '</select>';
        
        document.getElementById("comboUnit1Div").innerHTML = htmlunit1;
        document.getElementById("comboUnit2Div").innerHTML = htmlunit2;
        
        document.getElementById('VUnit1F').value = "";
        document.getElementById('VUnit2F').value = "";
    }
    SetStatus("offline","flyout");
    ShowLoadingF(false,true,"");
}
////////////////////////////////////////////////////////////////////////////////
//
// Wait for units
//
////////////////////////////////////////////////////////////////////////////////
function saveUnits()
{
    try
    {   
        
        if(req.readyState == 4 && req.status == 200 && req.responseText) 
        {
            reqCache = req.responseText; 
            req = null;
            ParseUnits(reqCache);
            //req.send();  
        }
        else if(req.readyState == 4 && req.status != 200)
        {
            //SetStatus("offline","flyout");
            //ShowLoadingF(true,true,"Getting units from Offline data...");
            // traer las unidades que haya en offline
            
            // Traer categorias Offline
            // Cargar unidades de Offline
        }
    }
    catch(e)
    {
        alert('error');
    }
}
////////////////////////////////////////////////////////////////////////////////
//
// Parse Units
//
////////////////////////////////////////////////////////////////////////////////
function ParseUnits(pData)
{
    try
    {
        SetStatus("online","flyout");
        var xmlDoc;
        if(window.ActiveXObject)
        {
            xmlDoc = new ActiveXObject("Microsoft.XMLDOM");
            xmlDoc.loadXML(pData);
        }
        var node = xmlDoc.documentElement.firstChild.firstChild.childNodes[1].firstChild;
        var units = node.getElementsByTagName("s:enumeration");
        
        var htmlcat = "";
        var htmlcat1 = '<select id="comboUnit1" class="combo">';
        var htmlcat2 = '<select id="comboUnit2" class="combo">';
        for(var i=0; i<units.length; i++)
        {
            htmlcat = htmlcat + '<option value="' + i + '" title="' + units[i].getAttributeNode("value").value + '"';
            if(units[i].getAttributeNode("value").value.length > 17)
            {
                htmlcat = htmlcat + '">' + units[i].getAttributeNode("value").value.substr(0,17) + '...';
            }
            else
            {
                htmlcat = htmlcat + '">' + units[i].getAttributeNode("value").value;
            }
            htmlcat = htmlcat + '</option>';
        } 
        htmlcat1 = htmlcat1 + htmlcat + '</select>';
        htmlcat2 = htmlcat2 + htmlcat + '</select>';
        
        document.getElementById("comboUnit1Div").innerHTML = htmlcat1;
        document.getElementById("comboUnit2Div").innerHTML = htmlcat2;
        document.getElementById('VUnit1F').value = "";
        document.getElementById('VUnit2F').value = "";
        ShowLoadingF(false,true,"");
    }
    catch(e)
    {  
        alert('error');
    }
}

///////////////////////////////////////////////////////////////////////////////
//
// ShowLoading of Flyout
//
////////////////////////////////////////////////////////////////////////////////
function ShowLoadingF(pValue, pShowSpinner, pText)
{
    try
    {
        var flyoutDiv = System.Gadget.Flyout.document;
        if (pValue) 
        {
            showOrHideF('messageF', true);
            showOrHideF('messageIconF', false);
            spinnerF.show();
            spinnerF.start();
            flyoutDiv.getElementById('messageSpinnerF').style.display = 'inline';
            flyoutDiv.getElementById('messageTextF').innerHTML = pText;
            if (pShowSpinner)showOrHideF('messageSpinnerF', true);
            else showOrHideF('messageSpinnerF', false);
        }
        else {
            spinnerF.stop();
            showOrHideF('messageF', false);
        }
    }
    catch (e)
    {
        alert('paso');
    }
}
///////////////////////////////////////////////////////////////////////////////
//
// SetFlyoutSettings onShow and onHide
//
////////////////////////////////////////////////////////////////////////////////
function SetFlyoutSettings()
{
    try
    {       
          System.Gadget.Flyout.onShow = function()
          {
            if(System.Gadget.Flyout.show)
            {
                document.getElementById("main").disabled = true;
            }
          } 
          
          System.Gadget.Flyout.onHide = function()
          {
            if(System.Gadget.Flyout.show)
            {
                document.getElementById("main").disabled = false;
                document.getElementById('VUnit1').value = "";
                document.getElementById('VUnit2').value = "";
                ShowLoading(false,false,"");  
            }
          }
    }
    catch(e)
    {
        alert('error');
    }
}
///////////////////////////////////////////////////////////////////////////////
//
// Make Conversion, convert a value from a unit to other
//
////////////////////////////////////////////////////////////////////////////////
function MakeConversionF()
{
    if(IsNum(document.getElementById('VUnit1F').value))
    {
        ShowLoadingF(true,true,"Converting...");
        if(comboUnit1.options(comboUnit1.selectedIndex).text == comboUnit2.options(comboUnit2.selectedIndex).text) {
            document.getElementById('VUnit2F').value = document.getElementById('VUnit1F').value;
            ShowLoadingF(false,false,"");
            return;
        }   
        if(comboCategory.options(comboCategory.selectedIndex).text != "Custom")
        {
            var url = comboCategory.options(comboCategory.selectedIndex).value.split(" ");
            var unit1 = comboUnit1.options(comboUnit1.selectedIndex).text;
            var unit2 = comboUnit2.options(comboUnit2.selectedIndex).text;
            var value = document.getElementById('VUnit1F').value;
            tmp = prepareURL(url[1],unit1,unit2,value);
            RequestServiceF(tmp);
        }
        else
        {
            ShowLoadingF(true,true,"Converting...");
            MakeConversionOffline("flyout","custom");
            ShowLoadingF(false,false,"");
        }
    }
    else
    {
         document.getElementById('VUnit2F').value = "Only Numbers";   
    } 
}
///////////////////////////////////////////////////////////////////////////////
//
// SaveResultF
//
////////////////////////////////////////////////////////////////////////////////
function saveResultF()
{
    try
    {   
        if(req.readyState == 4 && req.status == 200 && req.responseText) 
        {
            reqCache = req.responseText; 
            ParseResult(reqCache,"flyout");
            //req.send();  
        }
        else if(req.readyState == 4 && req.status != 200)
        {
            SetStatus("offline","flyout");
            ShowLoadingF(true,true,"Converting in Offline mode...");
            MakeConversionOffline("flyout");
            ShowLoadingF(false,false,"");
        }
    }
    catch(e){}
}
///////////////////////////////////////////////////////////////////////////////
//
// Ask for conversion result
//
////////////////////////////////////////////////////////////////////////////////
function RequestServiceF(pURL){
    try
    {   
        if(window.ActiveXObject)
        {
            req = null;
            req = new ActiveXObject("Microsoft.XMLHTTP");
            if(req)
            {
                req.onreadystatechange = saveResultF;
                req.open("GET", pURL, true);
                req.setRequestHeader("Cache-Control", "no-cache");
                req.setRequestHeader("Pragma", "no-cache");
                req.send();
            }        
        }
    }
    catch(e)
    {}
}
///////////////////////////////////////////////////////////////////////////////
//
// Set units to main gadget
//
////////////////////////////////////////////////////////////////////////////////
function SetPreferredUnits()
{
    System.Gadget.document.parentWindow.currentUnit1 = comboUnit1.options(comboUnit1.selectedIndex).title;
    System.Gadget.document.parentWindow.currentUnit2 = comboUnit2.options(comboUnit2.selectedIndex).title;
    System.Gadget.document.parentWindow.currentCategoryName = comboCategory.options(comboCategory.selectedIndex).text;
    System.Gadget.document.parentWindow.currentCategory = comboCategory.selectedIndex;
    SetUnits(comboUnit1.options(comboUnit1.selectedIndex).title, comboUnit2.options(comboUnit2.selectedIndex).title,"flyout");
    if(comboCategory.options(comboCategory.selectedIndex).text != "Custom")
        System.Gadget.document.parentWindow.currentOrigen = "ws";
    else 
        System.Gadget.document.parentWindow.currentOrigen = "custom";
           
    var tmp = System.Gadget.document.parentWindow.currentOrigen + " ";
    tmp = tmp + System.Gadget.document.parentWindow.currentUnit1 + " ";
    tmp = tmp + System.Gadget.document.parentWindow.currentUnit2 + " ";
    tmp = tmp + System.Gadget.document.parentWindow.currentCategory + " ";
    tmp = tmp + System.Gadget.document.parentWindow.currentCategoryName;
        
        
    ShowLoadingF(true,true,"Saving preferences!");    
    setPersistentSetting( "preferences", tmp , setCallback );   
}

function setCallback()
{
    setTimeout('ShowLoadingF(false,false,"")', 500);
}
///////////////////////////////////////////////////////////////////////////////
//
// Library
//
////////////////////////////////////////////////////////////////////////////////
function showOrHideF(oHTMLElement, bShowOrHide) {
    var flyoutDiv = System.Gadget.Flyout.document;
    if (typeof(oHTMLElement)=="string") { oHTMLElement = flyoutDiv.getElementById(oHTMLElement); }
    if (oHTMLElement && oHTMLElement.style) {
        oHTMLElement.style.display = (bShowOrHide) ? 'block' : 'none';
    }
} 

////////////////////////////////////////////////////////////////////////////////
//
// Spinner Animation
//
////////////////////////////////////////////////////////////////////////////////
function getSpinnerF( spinnerDivID ) 
{
  var flyoutDiv = System.Gadget.Flyout.document;
  var self = this;
  this.id = spinnerDivID;
  this.parentDiv = flyoutDiv.getElementById( self.id );
  this.fps = 1000/30;  
  with (this.parentDiv.style) {
    fontSize=0;
    posWidth=16;
    posHeight=16;
    backgroundImage = 'url("images/loading.png")';
    backgroundPositionY = 0;
  }
  this.hide  = function() { self.parentDiv.style.display='none';  }
  this.show  = function() { self.parentDiv.style.display='block'; }
  this.stop  = function() { clearInterval( self.animationInterval ); }
  this.start = function() {
    clearInterval( self.animationInterval );
    this.animationInterval = setInterval( 'animateF(' + self.id + ')', 30 );
  }
} 

function animateF(spinnerDiv) 
{
    spinnerDiv.style.backgroundPositionY=parseInt(spinnerDiv.style.backgroundPositionY)-16; 
}