////////////////////////////////////////////////////////////////////////////////
//
//                           Juan Pablo Ibaez 2007
//                      http://ing.juanpablo.googlepages.com
//                                    Copyrigth
//
////////////////////////////////////////////////////////////////////////////////

var spinner;                //Main Spinner
var spinnerF;               //Flyout Spinner
var wsURL = null;           //WebService URLs (Array)
var wsName = null;          //WebService Display Name (Array) 
var wsWSDL = null;          //WebService WSDL (Array)
var wsTotal = 0;            //Total number of WebService
var req = null;             //XmlHttpRequest
var reqCache = null;        //Cache of the WebServiceInfo 
var status;                 //Mode: Online or Offline
var wsLoaded = false;
var firstRun = false;       //Start Up of the Gadget

var currentOrigen = "";     
var currentUnit1 = "";
var currentUnit2 = "";
var currentCategory = "";
var currentCategoryName = "";

////////////////////////////////////////////////////////////////////////////////
//
// Load gadget's main function
//
////////////////////////////////////////////////////////////////////////////////
function loadMain()
{
    spinner = new getSpinner('messageSpinner');  
    ShowLoading(true,true,"Loading...");
        
    showMoreButton.attachEvent("onmouseover", function(){showMoreButton.style.backgroundImage = 'url(../images/showmore_over.png)';});
    showMoreButton.attachEvent("onclick", function(){showMoreButton.style.backgroundImage = 'url(../images/showmore_down.png)'; showFlyout();});
    showMoreButton.attachEvent("onmouseout", function(){showMoreButton.style.backgroundImage = 'url(../images/showmore_up.png)';});
    showMoreButton.attachEvent("onfocus", function(){showMoreButton.style.backgroundImage = 'url(../images/showmore_down.png)';});
    showMoreButton.attachEvent("onblur", function(){showMoreButton.style.backgroundImage = 'url(../images/showmore_up.png)';});
    
    SetFlyoutSettings();
    
    GetWsXML();  
    
//    System.Gadget.Flyout.file = "flyout.html";
//    System.Gadget.settingsUI = "settings.html";
//    System.Gadget.onShowSettings = LoadPreferences;
}
///////////////////////////////////////////////////////////////////////////////
//
// ParseResult
//
////////////////////////////////////////////////////////////////////////////////
function ParseResult(pValue, pFrom)
{
    var xmlDoc;
    if(window.ActiveXObject)
    {
        xmlDoc = new ActiveXObject("Microsoft.XMLDOM");
        xmlDoc.loadXML(pValue);
    }
    var node = xmlDoc.documentElement;
    if(pFrom == "flyout") {
        SetStatus("online","flyout");
        document.getElementById('VUnit2F').value = node.text;
        ShowLoadingF(false,true,"");
    } else {
        SetStatus("online");
        document.getElementById('VUnit2').value = node.text;
        ShowLoading(false,true,""); 
    }
}
///////////////////////////////////////////////////////////////////////////////
//
// SaveResult
//
////////////////////////////////////////////////////////////////////////////////
function saveResult()
{
    try
    {
        if(req.readyState == 4 && req.status == 200 && req.responseText) 
        {
            reqCache = req.responseText; 
            ParseResult(reqCache);
            //req.send();  
        }
        else if(req.readyState == 4 && req.status != 200)
        {
            SetStatus("offline");
            ShowLoading(true,true,"Converting in Offline mode...");
            setTimeout('MakeConversionOffline();', 500);
            ShowLoading(false,false,"");
        }
    }
    catch(e)
    {   
        alert('error');
    }
}
///////////////////////////////////////////////////////////////////////////////
//
// Make Conversion Offline, convert a value from 
// a unit to other in Offline Mode
//
////////////////////////////////////////////////////////////////////////////////
function MakeConversionOffline(pFrom,pType)
{
    try
    {      
        var dest = "";
        var dest1 = "\\data\\conversionsOffline.xml"
        var dest2 = "\\data\\conversionsCustom.xml"
        
        if(pType == "custom") dest = dest2;
        else dest = dest1; 
        
        var categoryName = "";
        this.valueUnit1 = "";
        this.valueUnit2 = "";
        var txtUnit1 = "";
        var txtUnit2 = "";
        if(pFrom == "flyout") {
            categoryName = comboCategory.options(comboCategory.selectedIndex).text;
            txtUnit1 = comboUnit1.options(comboUnit1.selectedIndex).text;
            txtUnit2 = comboUnit2.options(comboUnit2.selectedIndex).text;
            this.valueUnit1 = document.getElementById('VUnit1F');
            this.valueUnit2 = document.getElementById('VUnit2F');
        } else {
            categoryName = currentCategoryName;
            txtUnit1 = currentUnit1;
            txtUnit2 = currentUnit2;
            this.valueUnit1 = document.getElementById('VUnit1');
            this.valueUnit2 = document.getElementById('VUnit2');
        }
        if(txtUnit1 == txtUnit2)
        {
            this.valueUnit2.value = this.valueUnit1;
            return;
        }
        if(window.ActiveXObject)
        {
            var oFS = new ActiveXObject("Scripting.FileSystemObject");
            var path = System.Gadget.path;
            path = path.replace(/\\/g,"\\\\");
            path = path + dest;
            if(oFS.FileExists(path) == true)
            {
              var oFSFile = oFS.OpenTextFile(path,1)
              var strXML = oFSFile.readall();
              xmlDoc = new ActiveXObject("Microsoft.XMLDOM");
              xmlDoc.loadXML(strXML);

              var node = xmlDoc.documentElement;
              var categories = node.getElementsByTagName("Category");
              
              var categoryId = -1;
              // Si la categoria es Temperatura la conversion no es lineal
              // por lo cual no esta en el XML 
                            
              if(categoryName == "Temperature")
              {
                if(txtUnit1 == "degreeFahrenheit" && txtUnit2 == "degreeCelsius")
                {
                    this.valueUnit2.value = (5/9) * (this.valueUnit1.value - 32);
                }
                else if (txtUnit1 == "degreeCelsius" && txtUnit2 == "degreeFahrenheit")
                {
                    this.valueUnit2.value = (9/5) * this.valueUnit1.value + 32;
                } 
              }
              else
              {
                // Buscar si existe la categora
                for(var i=0; i<categories.length; i++)
                {
                    if(categories[i].getAttributeNode("Name").value == categoryName)
                    {
                        categoryId = i;  
                        break;
                    }
                }
                // Si encontro la categoria, buscar si existe la conversion
                if(categoryId != "-1")
                {
                    var conversionName = txtUnit1 + " to " + txtUnit2;
                    var conversions = categories[categoryId].getElementsByTagName("Conversion");
                    for(var i=0; i<conversions.length; i++)
                    {
                        if(conversions[i].getAttributeNode("Name").value == conversionName)
                        {
                            var tmp = conversions[i].getElementsByTagName("Factor").item(0).firstChild.data.replace(/,/g, ".");
                            this.valueUnit2.value = tmp * this.valueUnit1.value;
                            return;
                        }
                    }
                    this.valueUnit2.value = "No Conversion Factor.";
                }
                else { this.valueUnit2.value = "No Conversion Factor."; }
              }
            }
            else { this.valueUnit2.value = "Not Offline or Custom File."; }      
        }
        else { this.valueUnit2.value = "Error."; }
    }
    catch(e){}
}
///////////////////////////////////////////////////////////////////////////////
//
// Make Conversion, convert a value from a unit to other
//
////////////////////////////////////////////////////////////////////////////////
function MakeConversion()
{
    if(IsNum(document.getElementById('VUnit1').value))
    {
        ShowLoading(true,true,"Converting...");
        
        if(currentUnit1 == currentUnit2)
        {
            document.getElementById('VUnit2').value = document.getElementById('VUnit1').value;
            ShowLoading(false,false,"");
            return;
        }
        
        if(currentOrigen == "ws" || currentOrigen == "xml")
        {
            var url = "";
            if(wsURL != null) url = wsURL[currentCategory];
            else if(wsLoaded == false) GetWsXML(false);
            var tmp = prepareURL(url,currentUnit1,currentUnit2,document.getElementById('VUnit1').value);
            RequestService(tmp,saveResult);
        }
        else
        {
            MakeConversionOffline("main","custom");
            ShowLoading(false,false,"");
        }
    }
    else
    {
         document.getElementById('VUnit2').value = "Only Numbers";   
    } 
}
///////////////////////////////////////////////////////////////////////////////
//
// ShowFlyout and prepare information for flyout
//
////////////////////////////////////////////////////////////////////////////////
function showFlyout()
{   
  ShowLoading(true,false,"On flyout...");  
  if(System.Gadget.Flyout.show==false)
  {
    var htmlcat = "";
    if(status == "online")
    {
        htmlcat = '<select id="comboCategory" class="combo" onchange="LoadUnits();">';
        for(var i=0; i<wsName.length; i++)
        {
            htmlcat = htmlcat + '<option value="' + wsWSDL[i] + " " + wsURL[i];
            htmlcat = htmlcat + '">' + wsName[i];
            htmlcat = htmlcat + '</option>';
        } 
        htmlcat = AddCustomConversionCategory(htmlcat);
        htmlcat = htmlcat + '</select>';
    }
    else {
        if(window.ActiveXObject)
        {
            var oFS = new ActiveXObject("Scripting.FileSystemObject");
            var path = System.Gadget.path;
            path = path.replace(/\\/g,"\\\\");
            path = path + "\\data\\conversionsOffline.xml";
            if(oFS.FileExists(path) == true)
            {
              var oFSFile = oFS.OpenTextFile(path,1)
              var strXML = oFSFile.readall();
              xmlDoc = new ActiveXObject("Microsoft.XMLDOM");
              xmlDoc.loadXML(strXML);
              
              // Guardo el XML leido para pasarselo al Flyout;
              document.getElementById("xmlOffline").value = strXML;

              var node = xmlDoc.documentElement;
              var categories = node.getElementsByTagName("Category");
              
              htmlcat = '<select id="comboCategory" class="combo" onchange="LoadUnitsOffline(comboCategory.selectedIndex);">';
              for(var i=0; i<categories.length; i++)
              {
                 htmlcat = htmlcat + '<option value="' + categories[i].getAttributeNode("Name").value;
                 htmlcat = htmlcat + '">' + categories[i].getAttributeNode("Name").value;
                 htmlcat = htmlcat + '</option>';
              } 
              htmlcat = AddCustomConversionCategory(htmlcat);
              htmlcat = htmlcat + '</select>';
            }
        }
    }
    document.getElementById("data").value = htmlcat;
    document.getElementById("status").value = status;
    System.Gadget.Flyout.show = true;
  }
}
///////////////////////////////////////////////////////////////////////////////
//
// ShowLoading of main
//
////////////////////////////////////////////////////////////////////////////////
function ShowLoading(pValue, pShowSpinner, pText)
{
    if (pValue) 
    {
        showOrHide('message', true);
        showOrHide('messageIcon', false);
        spinner.show();
        spinner.start();
        document.getElementById('messageSpinner').style.display = 'inline';
        document.getElementById('messageText').innerHTML = pText;
        if (pShowSpinner)showOrHide('messageSpinner', true);
        else showOrHide('messageSpinner', false);
    }
    else
    {
        spinner.stop();
        showOrHide('message', false);
    }
}
////////////////////////////////////////////////////////////////////////////////
//
// Get XML with WebServices info
//
////////////////////////////////////////////////////////////////////////////////
function GetWsXML(pSyn)
{
    RequestService("http://ing.juanpablo.googlepages.com/WebServices.xml",saveWsInfo,pSyn);
    //RequestService("http://ing.juanpablo.googlepages.com/WebServices.xml?nocache="+Math.random(),saveWsInfo);
}
////////////////////////////////////////////////////////////////////////////////
//
// Save WebService's info in the cache
//
////////////////////////////////////////////////////////////////////////////////
function saveWsInfo(){
    try
    {   
        if(req.readyState == 4 && req.status == 200 && req.responseText) 
        {
            reqCache = req.responseText; 
            processWsInfo(); 
            req.send();  
        }
        else if(req.readyState == 4 && req.status != 200)
        {
            SetStatus("offline");
            LoadPreferences();
        }
    }
    catch(e)
    {
        //status offline
    }
}
////////////////////////////////////////////////////////////////////////////////
//
// Process WebService's info and set status
//
////////////////////////////////////////////////////////////////////////////////
function processWsInfo()
{
    try
    {
        wsLoaded = true;
        var xmlDoc;
        if(window.ActiveXObject)
        {
            xmlDoc = new ActiveXObject("Microsoft.XMLDOM");
            xmlDoc.loadXML(reqCache);
        }
        var node = xmlDoc.documentElement;
        var items = node.getElementsByTagName("WebService");
        wsTotal = items.length;
        
        wsURL = new Array();
        wsName = new Array();
        wsWSDL = new Array();  
        
        for(var i=0; i<items.length; i++)
        {
            wsURL[i] = items[i].getElementsByTagName("URL").item(0).firstChild.data;
            wsName[i] = items[i].getElementsByTagName("Name").item(0).firstChild.data;
            wsWSDL[i] = items[i].getElementsByTagName("WSDL").item(0).firstChild.data;
        }
        SetStatus("online");
        LoadPreferences();
    }
    catch(e)
    {  
    }
}
////////////////////////////////////////////////////////////////////////////////
//
// Load user's preferences
//
////////////////////////////////////////////////////////////////////////////////
function LoadPreferences()
{
    getPersistentSetting("preferences", getCallback );    
}

function getCallback(value)
{
    if(value != null && value != "")
    {
        var tmp = value.split(" ");
        currentOrigen = tmp[0];
        currentUnit1 = tmp[1];
        currentUnit2 = tmp[2];
        currentCategory = tmp[3];
	    currentCategoryName = tmp[4];
    }
    else
    {
        currentOrigen = "ws";
        currentUnit1 = "degreeFahrenheit";
        currentUnit2 = "degreeCelsius";
        currentCategory = "8";
        currentCategoryName ="Temperature";
    }
    if(firstRun == false)
    {
        System.Gadget.Flyout.file = "flyout.html";
        System.Gadget.settingsUI = "settings.html";
        System.Gadget.onShowSettings = LoadPreferences;
        firstRun = true;
    }
    
    SetUnits(currentUnit1, currentUnit2);
    ShowLoading(false,false,"");
}

////////////////////////////////////////////////////////////////////////////////
//
// SetUnits in UI
//
////////////////////////////////////////////////////////////////////////////////
function SetUnits(pUnit1, pUnit2,pFrom)
{
    var tmp1 = pUnit1;
    var tmp2 = pUnit2;
    if(pUnit1.length > 17)
    { 
        tmp1 = pUnit1.substr(0,14) + "...";
    }
    if(pUnit2.length > 17)
    { 
        tmp2 = pUnit2.substr(0,14) + "...";
    }
    if(pFrom == "flyout") {
        System.Gadget.document.parentWindow.TUnit1.title = pUnit1;
        System.Gadget.document.parentWindow.TUnit1.innerHTML = tmp1;
        System.Gadget.document.parentWindow.TUnit2.title = pUnit2;
        System.Gadget.document.parentWindow.TUnit2.innerHTML = tmp2;
    } else {
        document.getElementById('TUnit1').title = pUnit1;
        document.getElementById('TUnit1').innerHTML = tmp1;
        document.getElementById('TUnit2').title = pUnit2;
        document.getElementById('TUnit2').innerHTML = tmp2;
    }
}
////////////////////////////////////////////////////////////////////////////////
//
// SetStatus
//
////////////////////////////////////////////////////////////////////////////////
function SetStatus(pStatus,pFrom)
{
    status = pStatus;
    if(pFrom == "flyout") {
        var flyoutDiv =  System.Gadget.Flyout.document;
        if(status == "offline") {
            flyoutDiv.getElementById('statusImageF').innerHTML = '<img alt="Working in Offline Mode" longdesc="There is no Internet connection, only offline conversions can be made." src="../../images/statusOffline.png"/></img>'; 
        } else {
            flyoutDiv.getElementById('statusImageF').innerHTML = '<img alt="Working in Online Mode" longdesc="AllToAll Converter is fully functionally." src="../../images/statusOnline.png"/></img>'; 
        }
    } else {
        if(status == "offline") {
            document.getElementById('statusImage').innerHTML = '<img alt="Working in Offline Mode" longdesc="There is no Internet connection, only offline conversions can be made." src="../../images/statusOffline.png"/></img>'; 
        } else {
            document.getElementById('statusImage').innerHTML = '<img alt="Working in Online Mode" longdesc="AllToAll Converter is fully functionally." src="../../images/statusOnline.png"/></img>'; 
        }
    }
}
///////////////////////////////////////////////////////////////////////////////
//
// If there is a custom conversion add "Custom" Cagegory
//
///////////////////////////////////////////////////////////////////////////////
function AddCustomConversionCategory(htmlcat)
{
    if(window.ActiveXObject)
    {
        var oFS = new ActiveXObject("Scripting.FileSystemObject");
        var path = System.Gadget.path;
        path = path.replace(/\\/g,"\\\\");
        path = path + "\\data\\conversionsCustom.xml";
        if(oFS.FileExists(path) == true)
        {
          var oFSFile = oFS.OpenTextFile(path,1)
          var strXML = oFSFile.readall();
          xmlDoc = new ActiveXObject("Microsoft.XMLDOM");
          xmlDoc.loadXML(strXML);
          
          // Guardo el XML leido para pasarselo al Flyout;
          document.getElementById("xmlCustom").value = strXML;
          
          var node = xmlDoc.documentElement;
          var categories = node.getElementsByTagName("Category");
          var conversions = categories[0].getElementsByTagName("Conversion");
            
          if(conversions.length > 0)
          {
             htmlcat = htmlcat + '<option value="' + categories[0].getAttributeNode("Name").value;
             htmlcat = htmlcat + '">' + categories[0].getAttributeNode("Name").value;
             htmlcat = htmlcat + '</option>';
          }
        }
    }
    return htmlcat;
}
///////////////////////////////////////////////////////////////////////////////
//
// Library
//
///////////////////////////////////////////////////////////////////////////////

function showOrHide(oHTMLElement, bShowOrHide) {
    if (typeof(oHTMLElement)=="string") { oHTMLElement = document.getElementById(oHTMLElement); }
    if (oHTMLElement && oHTMLElement.style) {
        oHTMLElement.style.display = (bShowOrHide) ? 'block' : 'none';
    }
} 

function prepareURL(pURL,pUnit1,pUnit2,pValue)
{
    if(pURL+"" != "" && pURL+"" != "undefined" && pURL+"" != "null")
    {
        var tmp = pURL.split("&");
        tmp[0] = tmp[0].substr(0,tmp[0].length-6) + pValue + "&";
        tmp[1] = tmp[1].substr(0,tmp[1].length-6) + pUnit1 + "&";
        tmp[2] = tmp[2].substr(0,tmp[2].length-6) + pUnit2;
        return tmp[0] + tmp[1] + tmp[2];
    } else return "error";
}

function RequestService(pURL,pParseFunction,pSyn){
    try
    {   
        if(window.ActiveXObject)
        {
            if(pSyn == null || pSyn == "undefined") pSyn = true;
            req = null;
            req = new ActiveXObject("Microsoft.XMLHTTP");
            if(req)
            {
                req.onreadystatechange = pParseFunction;
                req.open("GET", pURL, pSyn);
                req.setRequestHeader("Cache-Control", "no-cache");
                req.setRequestHeader("Pragma", "no-cache");
                req.send();
            }        
        }
    }
    catch(e)
    {}
}

function IsNum(numstr) 
{
    // Return immediately if an invalid value was passed in
    if (numstr+"" == "undefined" || numstr+"" == "null" || numstr+"" == "")
    { 
    return false;
    }
    var isValid = true;
    var decCount = 0; // number of decimal points in the string
    // convert to a string for performing string comparisons.
    numstr += ""; 
    // Loop through string and test each character. If any
    // character is not a number, return a false result.
    // Include special cases for negative numbers (first char == '-')
    // and a single decimal point (any one char in string == '.'). 
    for (i = 0; i < numstr.length; i++) 
    {
        // track number of decimal points
        if (numstr.charAt(i) == ".")
        {
            decCount++;
        }
        if (!((numstr.charAt(i) >= "0") && (numstr.charAt(i) <= "9") || 
           (numstr.charAt(i) == "-") || (numstr.charAt(i) == "."))) 
        {
            isValid = false;
            break;
        } else if ((numstr.charAt(i) == "-" && i != 0) ||
                  (numstr.charAt(i) == "." && numstr.length == 1) ||
                  (numstr.charAt(i) == "." && decCount > 1)) {
        isValid = false;
        break;
        } 
        //if (!((numstr.charAt(i) >= "0") && (numstr.charAt(i) <= "9")) || 
    } 
    return isValid;
}

////////////////////////////////////////////////////////////////////////////////
//
// Spinner Animation
//
////////////////////////////////////////////////////////////////////////////////
function getSpinner( spinnerDivID ) 
{
  var self = this;
  this.id = spinnerDivID;
  this.parentDiv = document.getElementById( self.id );
  this.fps = 1000/30;  
  with (this.parentDiv.style) {
    fontSize=0;
    posWidth=16;
    posHeight=16;
    backgroundImage = 'url("images/loading.png")';
    backgroundPositionY = 0;
  }
  this.hide  = function() { self.parentDiv.style.display='none';  }
  this.show  = function() { self.parentDiv.style.display='block'; }
  this.stop  = function() { clearInterval( self.animationInterval ); }
  this.start = function() {
    clearInterval( self.animationInterval );
    this.animationInterval = setInterval( 'animate(' + self.id + ')', 30 );
  }
} 

function animate(spinnerDiv) 
{
    spinnerDiv.style.backgroundPositionY=parseInt(spinnerDiv.style.backgroundPositionY)-16; 
}