////////////////////////////////////////////////////////////////////////////////
//
//                           Juan Pablo Ibaez 2007
//                      http://ing.juanpablo.googlepages.com
//                                    Copyrigth
//
////////////////////////////////////////////////////////////////////////////////

var xmlDoc = null;

function initSettings()
{
    Reset.attachEvent("onmouseover", function(){ Reset.style.color = '3300ff';});
    Reset.attachEvent("onmouseout", function(){ Reset.style.color = '000000';});
    Reset.attachEvent("onclick", function(){ Reset.style.color = 'lime';});
    Reset.attachEvent("onfocus", function(){ Reset.style.color = '3300ff';});
    Reset.attachEvent("onblur", function(){ Reset.style.color = '000000';});
    
    Update.attachEvent("onmouseover", function(){ Update.style.color = '3300ff';});
    Update.attachEvent("onmouseout", function(){ Update.style.color = '000000';});
    Update.attachEvent("onclick", function(){ Update.style.color = 'lime';});
    Update.attachEvent("onfocus", function(){ Update.style.color = '3300ff';});
    Update.attachEvent("onblur", function(){ Update.style.color = '000000';});
    
    System.Gadget.onSettingsClosing = settingsClosing;
    readCustomConversions();
}

function readCustomConversions()
{
    try
    {
        if(window.ActiveXObject)
        {
            var oFS = new ActiveXObject("Scripting.FileSystemObject");
            var path = System.Gadget.path;
            path = path.replace(/\\/g,"\\\\");
            path = path + "\\data\\conversionsCustom.xml";
            if(oFS.FileExists(path) == true)
            {
              var oFSFile = oFS.OpenTextFile(path,1)
              var strXML = oFSFile.readall();

              xmlDoc = new ActiveXObject("Microsoft.XMLDOM");
              xmlDoc.loadXML(strXML);

              var node = xmlDoc.documentElement;
              var category = node.getElementsByTagName("Category");
              var conversions = node.getElementsByTagName("Conversion");    
              
              for(var i=0; i<conversions.length; i++)
              {
                  var conversionName = conversions[i].getAttributeNode("Name").value;
                  var conversionFactor = conversions[i].getElementsByTagName("Factor").item(0).firstChild.data;
                  readElement(conversionName, conversionFactor);
              }
            }   
        }
    }catch(e){}
}

function deleteCustomConversions()
{
  var number = 0;
  var oList = document.getElementById("conversionsList");
  if(oList.selectedIndex<0)return;
  
  var tmp = oList.children[oList.selectedIndex].text.split(" ");
  tmp = tmp[2] + " to " + tmp[0];
  try
  {
    if(oList.children[oList.selectedIndex + 1].text == tmp) number = 0;
    else number = - 1;
  }
  catch(e)
  {
    number = -1;
  }

  // Delete from XML
  var node = xmlDoc.documentElement;
  var category = node.getElementsByTagName("Category");
  var conversions = node.getElementsByTagName("Conversion");
  
  for(var i=0; i<conversions.length; i++)
  {
    if(oList.children[oList.selectedIndex].text == conversions[i].getAttributeNode("Name").value)
    {
        category[0].removeChild(category[0].childNodes.item(i));
        category[0].removeChild(category[0].childNodes.item(i+number));
        break;
    }
  }
  
  // Delete from HTML
  number = oList.selectedIndex + number;
  oList.remove(oList.selectedIndex);
  oList.remove(number);
  
  clearCustomConversions();
}

function addCustomConversions()
{
    if(validateCustomConversions())
    {
        var tmp = TrimAll(document.getElementById("txtFrom").value) + " to " + TrimAll(document.getElementById("txtTo").value);
        addElement(tmp,TrimAll(document.getElementById("txtFactor").value));
        AddElementToXML(tmp,TrimAll(document.getElementById("txtFactor").value));
    }
}

function readElement(pConversionName, pConversionFactor)
{
  // Add to HTML
  var oList = document.getElementById("conversionsList");
  var newElement;
  newElement = document.createElement("OPTION");
  newElement = new Option(pConversionName,pConversionFactor);
  oList.add(newElement);
}

function addElement(pConversionName, pConversionFactor)
{
  // Add to HTML
  var oList = document.getElementById("conversionsList");
  var newElement;
  newElement = document.createElement("OPTION");
  newElement = new Option(pConversionName,pConversionFactor);
  oList.add(newElement);
  
  var tmp = pConversionName.split(" ");
  pConversionName = tmp[2] + " to " + tmp[0];
  pConversionFactor = 1 / pConversionFactor;
  
  newElement = document.createElement("OPTION");
  newElement = new Option(pConversionName,pConversionFactor);
  oList.add(newElement);
  
}

function AddElementToXML(pConversionName, pConversionFactor)
{
  //Add to XML
  var node = xmlDoc.documentElement;
  var category = node.getElementsByTagName("Category");
  
  var newConversion = xmlDoc.createNode(1,"Conversion","");
  newConversion.setAttribute("Name", pConversionName);
  var factor = xmlDoc.createElement("Factor");
  factor.text = pConversionFactor;
  newConversion.appendChild(factor);
  category[0].appendChild(newConversion);
  
  var tmp = pConversionName.split(" ");
  pConversionName = tmp[2]+ " to " + tmp[0];
  pConversionFactor = 1 / pConversionFactor;
 
  newConversion = xmlDoc.createNode(1,"Conversion","");
  newConversion.setAttribute("Name", pConversionName);
  factor = xmlDoc.createElement("Factor");
  factor.text = pConversionFactor;
  newConversion.appendChild(factor);
  category[0].appendChild(newConversion);
  
}

function showCustomConversions()
{
    var oList = document.getElementById("conversionsList");
    if(oList.selectedIndex != "-1") {
        var customConversionName = oList.children[oList.selectedIndex].text.split(" ");
        var customConversionFactor = oList.children[oList.selectedIndex].value;
    
        document.getElementById("txtFrom").value = customConversionName[0];
        document.getElementById("txtTo").value = customConversionName[2];
        document.getElementById("txtFactor").value = customConversionFactor;
    }
}

function validateCustomConversions()
{
    var tmp = true;
    // Validate Only Numbers in Factor Box
    if(IsNum(document.getElementById("txtFactor").value))
        document.getElementById("errorFactor").innerHTML = "";
    else {
        tmp = false;
        document.getElementById("errorFactor").innerHTML = '<img alt="Solo Nmeros" src="../../images/statusOffline.png"/></img>'; 
    }
    
    // Validate Not Empty Values in TO and FROM boxes
    var from = document.getElementById("txtFrom").value;
    var to = document.getElementById("txtTo").value;
    
    if(from == to) {
        document.getElementById("errorFrom").innerHTML = '<img alt="Misma unidad" src="../../images/statusOffline.png"/></img>'; 
        document.getElementById("errorTo").innerHTML = '<img alt="Misma unidad" src="../../images/statusOffline.png"/></img>'; 
        return false;
    }
    
    if(from == "") {
        tmp = false;
        document.getElementById("errorFrom").innerHTML = '<img alt="Unidad Desde" src="../../images/statusOffline.png"/></img>'; 
    } else {
        document.getElementById("errorFrom").innerHTML = "";
    }
    
    if(to == "") {
        tmp = false;
        document.getElementById("errorTo").innerHTML = '<img alt="Unidad A" src="../../images/statusOffline.png"/></img>'; 
    } else {
        document.getElementById("errorTo").innerHTML = "";
    }
    var oList = document.getElementById("conversionsList");
    for(var i=0; i<oList.children.length; i++)
    {
        if(oList.children[i].text == from + " to " + to)
        {
            document.getElementById("errorFrom").innerHTML = '<img alt="Conversin Existente" src="../../images/statusOffline.png"/></img>'; 
            document.getElementById("errorTo").innerHTML = '<img alt="Conversin Existente" src="../../images/statusOffline.png"/></img>'; 
            return false;
        }
    }
    return tmp;
}

function clearCustomConversions()
{
    document.getElementById("txtFrom").value = "";
    document.getElementById("txtTo").value = "";
    document.getElementById("txtFactor").value = "";
    
    document.getElementById("errorTo").innerHTML = "";
    document.getElementById("errorFrom").innerHTML = "";
    document.getElementById("errorFactor").innerHTML = "";
}

function Save()
{
    var oFS = new ActiveXObject("Scripting.FileSystemObject");
    var path = System.Gadget.path;
    path = path.replace(/\\/g,"\\\\");
    path = path + "\\data\\conversionsCustom.xml";
    var oFSFile = oFS.OpenTextFile(path,2,true);
    oFSFile.write(xmlDoc.xml); 
    oFSFile.close();
}

function settingsClosing(event)
{
    if(event.closeAction == event.Action.commit)
    {
        // Write XML
        Save();
    }
    else if (event.closeAction == event.Action.cancel)
    {
    }
    event.cancel = false;
}

function ResetUnits()
{
    Reset.innerHTML = "Unidades Reseteadas";
    Reset.style.color = "lime";
    setPersistentSetting( "preferences", "" , setCallbackReset );  
}

function setCallbackReset()
{
    setTimeout('Reset.innerHTML = "Resetear Unidades Preferidas"; Reset.style.color = "black";', 1000);
}

function UpdateUnits()
{
    Update.innerHTML = "Actualizando...";
    Update.style.color = "red";
    RequestService("http://ing.juanpablo.googlepages.com/conversionsOffline.xml",parseUpdate)
}

function parseUpdate()
{
    try
    {   
        if(req.readyState == 4 && req.status == 200 && req.responseText) 
            SaveUpdate(req.responseText);
        else if(req.readyState == 4 && req.status != 200)
        {
            Update.innerHTML = "Actualizacin Fallida!!!";
            setTimeout('Update.style.color = "black"; Update.innerHTML = "Actualizar Unidades Offline";', 1000);
        }
    }
    catch(e){}
}

function SaveUpdate(pUpdate)
{
    var oFS = new ActiveXObject("Scripting.FileSystemObject");
    var path = System.Gadget.path;
    path = path.replace(/\\/g,"\\\\");
    path = path + "\\data\\conversionsOffline.xml";
    var oFSFile = oFS.OpenTextFile(path,2,true);
    oFSFile.write(pUpdate); 
    oFSFile.close();
    Update.style.color = "lime";
    Update.innerHTML = "Actualizacin Terminada!!!"
    setTimeout('Update.innerHTML = "Actualizar Unidades Offline"; Update.style.color = "black";', 1000);
}